


;/////////////////////////////////////////////////////////////////
;
;	PIC16F/12F/10FpEEPROM G~[V TuvO
;
;		(2013.10.29 Revision 10)
;
;	<t@NV>
;	1.initial_eeprom	EEPROM̈̏AS0xFFށB
;	2.read_eeprom		wAhX̃f[^EE_DATɕԂB
;	3.erase_eeprom		wAhX̃f[^B
;	4.write_eeprom		f[^wAhXɏށB
;
;	0x00=<EE_ADR<0x3F	EEPROMAhX(6rbg)
;	0x00=<EE_DAT=<0xFF	EEPROMf[^(8rbg)
;
;	<gp@>
;	1	call	initial_eeprom
;
;	2	movwf	EE_ADR
;		call	read_eeprom
;
;	3	movwf	EE_ADR
;		call	erase_eeprom
;
;	4	movwf	EE_ADR
;		movwf	EE_DAT
;		call	write_eeprom
;
;	<[h/CgXe[^X>
;	read/write status    ---->   ͈͊ÕAhXw肵		flag,7=1 
;	read status          ---->   wAhXɃf[^݂Ȃ	flag,6=1 
;
;	[]
;	@call initial_eeprom 
;
;	@߂l: EE_ADR=ێ, EE_DAT=ێ, flag=0x00
;
;	AEE_ADR=0x44, EE_DAT=0x42, call write_eeprom 
;
;	@߂l: EE_ADR=0x44(ێ), EE_DAT=0x42(ێ), flag=0x80 ȂŖ߂
;
;	BEE_ADR=0x3F, call read_eeprom 
;
;	@߂l: EE_ADR=0x3F(ێ), EE_DAT=ێ, flag=0x80 ȂŖ߂
;
;	CEE_ADR=0x25, EE_DAT=0x42, call write_eeprom 
;
;	@߂l: EE_ADR=0x25(ێ)܂0x3F, EE_DAT=s, flag=0x00 ݎ{
;
;	DEE_ADR=0x22, call read_eeprom 
;
;	@EEPROM(0x22) ݍς(=0x37)̂Ƃ@߂l: EE_DAT=0x37, EE_ADR=0x22(ێ), flag=0x00
;
;	@EEPROM(0x22) ς(=0xFF)̂Ƃ      ߂l: EE_DAT=0xFF, EE_ADR=0x22(ێ), flag=0x00
;
;	@EEPROM(0x22) ݑÔƂ	    ߂l: EE_DAT=0xFF, EE_ADR=0x22(ێ), flag=0x40
;
;/////////////////////////////////////////////////////////////////

; --------------------------------------------------------------------
;		RAM̐ݒ
; --------------------------------------------------------------------
;
        cblock	0x70
	  EE_ADR			;EEPROM Address (0x00=<EE_ADR<0x3F)
	  EE_DAT			;EEPROM Data    (8bits)
	  flag				;read/write status, address error :flag,7=1
	endc				;read status,       data not exist:flag,6=1

r_flag	equ	EE_ADR
count	equ	flag
tmp_adr	equ	flag

; --------------------------------------------------------------------
;		foCXɂݒ
; --------------------------------------------------------------------

;PMADRH	equ	EEADRH		;PMADRH݂ȂƂRg
;PMADRL	equ	EEADRL		;
;PMDATH	equ	EEDATH		;
;PMDATL	equ	EEDATL		;
;PMCON1	equ	EECON1		;
;PMCON2	equ	EECON2		;
;
;   +-------------+-------------------+----------+	|		|
;   |   Device    | PMADRH/L,PMADRH/L | PMCON1/2 |	| PIC16F/12F/10F|
;   +-------------+-------------------+----------+	|		|
;   |  PIC10F32X  |       BANK 0      |  BANK 0  |	+---------------+EETOP +
;   +-------------+-------------------+----------+	|		|      |
;   |  PIC12F617  |       BANK 1      |  BANK 1  |	|  Sub Program  |      |EESIZE
;   +-------------+-------------------+----------+	|		|      |
;   |  PIC16F72X  |       BANK 2      |  BANK 3  |	+---------------+PAGE0 +
;   +-------------+-------------------+----------+	|     PAGE0	|      |PWIDTH
;   |  PIC16F75X  |       BANK 3      |  BANK 3  |	+---------------+PAGE1 +
;   +-------------+-------------------+----------+	|     PAGE1	|      |PWIDTH
;   |  PIC16F1XXX |       BANK 3  @@|  BANK 3  |	+---------------+      +
;   +-------------+-------------------+----------+	|		|
;
#define	EPSIZE	0x20			;y[W̑傫 ([h)A[U[Y}jAQƂ̂
#define	BNK	3			;PMADRH/LPMDATH/LzuĂoN(0/1/2/3)
;
#define	EETOP	0x0300			;TuvO̊Jnʒu
#define	EESIZE	0x80			;TuvÕTCY
#define	PWIDTH	0x40			;EEPROMy[WTCY
#define	PAGE0	EETOP+EESIZE		;EEPROM Page0
#define	PAGE1	EETOP+EESIZE+PWIDTH	;EEPROM Page1


		ORG	EETOP

; ********************************************************************
;
;		Initial EEPROM
;
; ********************************************************************

initial_eeprom:
		call	set_PAGE0		;PMADR = PAGE0
		movlw	2*PWIDTH/EPSIZE		;count = 2*PWIDTH/EPSIZE
		goto	erase_page10		;y[W0ƃy[W1

; ********************************************************************
;
;		Read EEPROM
;
; ********************************************************************

read_eeprom:
		call	set_pointer		;y[WIAwAhX`FbN
		btfsc	flag,7
		return				;G[^[

		call	read_data		;wAhX̃f[^ǂݏo
		clrf	flag			;Xe[^XtONA
		btfss	r_flag,6		;wAhX̃f[^݂
		bsf	flag,6			;wAhX̃f[^݂Ȃ
		bcf	r_flag,6		;r_flag,6NA
		goto	all_ret			;^[

; ********************************************************************
;
;		Erase EEPROM
;
; ********************************************************************

erase_eeprom:
		movlw	0xFF			;EE_DAT = 0xFF
		movwf	EE_DAT

; ********************************************************************
;
;		Write EEPROM
;
; ********************************************************************

write_eeprom:
		call	set_pointer		;y[WIAwAhX`FbN
		btfsc	flag,7
		return				;G[^[

		movf	PMADRL,w		;tmp_adr = PMADRL
		movwf	tmp_adr

write_eeprom_data:
		call	rd			;y[W̃f[^ǂݏo
		movlw	0x3F			;W = PMDATH - 0x3F
		subwf	PMDATH,w
		skpz				;f[^܂ĂȂ
		goto	next_data		;f[^܂Ă

		movf	EE_ADR,w		;PMDATH = EE_ADR
		movwf	PMDATH
		movf	EE_DAT,w		;PMDATL = EE_DAT
		movwf	PMDATL
		call	wr_w			;f[^
		goto	check_eeprom

next_data:
		incf	PMADRL,f		;PMADRL = PMADRL + 1
		goto	write_eeprom_data	;̃f[^ǂݏo

check_eeprom:
		incf	PMADRL,w		;W = AND(PMADRL+1,b'00111111')
		andlw	b'00111111'
		skpz				;ݏꏊy[W̍ŌȂXLbv
		goto	clr_status		;ݏꏊy[W̍ŌłȂ΃^[

copy_eeprom:					;݂̃y[W̃f[^ĕʂ̃y[WɃRs[
		clrf	EE_ADR			;EE_ADR = 0

copy_data:
		movf	tmp_adr,w		;PMADRRs[y[W̐擪ɐݒ
		andlw	b'11000000'
		movwf	PMADRL
		call	read_data		;EEPROMf[^擾
		btfss	r_flag,6		;f[^݂
		goto	no_data			;f[^݂͑Ȃ

		bcf	r_flag,6		;clear flag
		movf	tmp_adr,w		;PMADRL = Rs[y[W
		xorlw	PWIDTH
		movwf	PMADRL
		movf	EE_ADR,w		;PMDATH = EE_ADR
		movwf	PMDATH
		movf	EE_DAT,w		;PMDATL = EE_DAT
		movwf	PMDATL
		incf	tmp_adr,f		;tmp_adr = tmp_adr + 1
		call	wr_w			;EEPROMf[^Rs[̃y[WɃRs[

no_data:
		incf	EE_ADR,f		;EE_ADR = EE_ADR + 1
		movlw	0x3F			;W = EE_ADR - 0x3F
		subwf	EE_ADR,w
		skpz				;f[^Rs[
		goto	copy_data		;̃f[^Rs[

		movf	tmp_adr,w		;PMADRRs[y[W̐擪ɐݒ
		andlw	b'11000000'
		movwf	PMADRL

erase_page:					;y[W
		movlw	PWIDTH/EPSIZE		;count = PWIDTH/EPSIZE
erase_page10:
		movwf	count
erase_loop:
		call	wr_e			;y[WTCY
		movlw	EPSIZE			;PMADRL = PMADRL + EPSIZE
		addwf	PMADRL,f
		decfsz	count,f
		goto	erase_loop
clr_status:
		clrf	flag			;Xe[^XtONA
all_ret:					;SẴt@NV̏o
		clrf	STATUS			;BANK 0
		return


;/////////////////////////////////////////////////////////////////
;
;		Tu[`
;
;/////////////////////////////////////////////////////////////////

; --------------------------------------------------------------------
;
;		PMADRLy[W̐擪ɐݒ
;		AhX͈͊OȂAflag,7ZbgĖ߂
;
; --------------------------------------------------------------------

set_pointer:
		clrf	flag			;Xe[^XtONA
		movlw	0x3F			;W=EE_ADR-0x3F
		subwf	EE_ADR,w
		skpnc				;EE_ADR < 0x3F
		bsf	flag,7			;Xe[^XtOZbg
		movlw	(PAGE1 & 0xFF)		;PMADRy[W1̐擪ɐݒ
		call	set_PAGE10

		call	rd			;y[W1̐擪f[^ǂݏo
		movlw	0x3F			;W = PMDATH - 0x3F
		subwf	PMDATH,w
		skpz				;y[W1͖gp
		return				;^[

set_PAGE0:
		movlw	(PAGE0 & 0xFF)		;PMADRy[W0̐擪ɐݒ
set_PAGE10:					;SẴt@NV͂ʉ߂̂
						;oN̐؂ւōsȂB
	#IF BNK==3
		bsf	STATUS,RP0		;BANK3
		bsf	STATUS,RP1
	#ENDIF
	#IF BNK==2
		bcf	STATUS,RP0		;BANK2
		bsf	STATUS,RP1		;BANK2̏ꍇ̂PMCON1/2̃oN3ƂȂB
	#ENDIF
	#IF BNK==1
		bsf	STATUS,RP0		;BANK1
		bcf	STATUS,RP1
	#ENDIF
		movwf	PMADRL
		movlw	((PAGE0>>8) & 0xFF)
		movwf	PMADRH

	#IF BNK==2
		bsf	STATUS,RP0	; BANK3
	#ENDIF
		clrf	PMCON1			;PMCON1NA
	#IF BNK==2
		bcf	STATUS,RP0	; BANK2
	#ENDIF

		return				;^[

; --------------------------------------------------------------------
;
;	EE_ADRŎw肳ꂽAhXōŌɏ܂ꂽf[^擾
;
;		  : PMADR, EE_ADR
;		߂l: EE_DAT, f[^݂Ƃr_flag,6Zbg
;
; --------------------------------------------------------------------

read_data:
		bcf	r_flag,6	;clear r_flag
		movlw	0xFF		;EE_DAT̏l=0xFF
		movwf	EE_DAT
rd_loop:
		call	rd		;1[hǂݏo
		movf	EE_ADR,w	;W = PMDATH(<0x40)
		andlw	b'00111111'	;
		subwf	PMDATH,w	;W = PMDATH - W
		skpz			;AhXEE_ADRƈv
		goto	$+4		;AhXEE_ADRƈvȂ

		movf	PMDATL,w	;EE_DATɒlZbg
		movwf	EE_DAT
		bsf	r_flag,6	;r_flag,6Zbg

		incf	PMADRL,f	;PMADRL = PMADRL + 1
		movlw	b'00111111'
		andwf	PMADRL,w
		skpz			;y[W̍ŌɓB烊^[
		goto	rd_loop
		return

; --------------------------------------------------------------------
;
;		tbV̓ǂݏo//
;
;		o: PMADRH/L, PMDATH/L
;
; --------------------------------------------------------------------

wr_e:					; y[WTCY
	#IF BNK==2
		bsf	STATUS,RP0	; BANK3
	#ENDIF
		bsf	PMCON1,FREE
wr_w:					; 1[h
	#IF BNK==2
		bsf	STATUS,RP0	; BANK3
	#ENDIF
		bsf	PMCON1,WREN
		movlw   0x55
                movwf   PMCON2
                movlw   0xaa
                movwf   PMCON2
		bsf	PMCON1,WR
rd:					; 1[hǂݏo
	#IF BNK==2
		bsf	STATUS,RP0	; BANK3
	#ENDIF
		bsf	PMCON1,RD
                nop
                nop
		clrf	PMCON1
	#IF BNK==2
		bcf	STATUS,RP0	; BANK2
	#ENDIF
		return

; ********************************************************************



        	END
